const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class GoalsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const goals = await db.goals.create(
      {
        id: data.id || undefined,

        type: data.type || null,
        title: data.title || null,
        metric: data.metric || null,
        target: data.target || null,
        start: data.start || null,
        due: data.due || null,
        progress: data.progress || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await goals.setEmployee(data.employee || null, {
      transaction,
    });

    await goals.setOrganizations(data.organizations || null, {
      transaction,
    });

    return goals;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const goalsData = data.map((item, index) => ({
      id: item.id || undefined,

      type: item.type || null,
      title: item.title || null,
      metric: item.metric || null,
      target: item.target || null,
      start: item.start || null,
      due: item.due || null,
      progress: item.progress || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const goals = await db.goals.bulkCreate(goalsData, { transaction });

    // For each item created, replace relation files

    return goals;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const goals = await db.goals.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.type !== undefined) updatePayload.type = data.type;

    if (data.title !== undefined) updatePayload.title = data.title;

    if (data.metric !== undefined) updatePayload.metric = data.metric;

    if (data.target !== undefined) updatePayload.target = data.target;

    if (data.start !== undefined) updatePayload.start = data.start;

    if (data.due !== undefined) updatePayload.due = data.due;

    if (data.progress !== undefined) updatePayload.progress = data.progress;

    updatePayload.updatedById = currentUser.id;

    await goals.update(updatePayload, { transaction });

    if (data.employee !== undefined) {
      await goals.setEmployee(
        data.employee,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await goals.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return goals;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const goals = await db.goals.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of goals) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of goals) {
        await record.destroy({ transaction });
      }
    });

    return goals;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const goals = await db.goals.findByPk(id, options);

    await goals.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await goals.destroy({
      transaction,
    });

    return goals;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const goals = await db.goals.findOne({ where }, { transaction });

    if (!goals) {
      return goals;
    }

    const output = goals.get({ plain: true });

    output.employee = await goals.getEmployee({
      transaction,
    });

    output.organizations = await goals.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'employee',

        where: filter.employee
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.employee
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.employee
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.title) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('goals', 'title', filter.title),
        };
      }

      if (filter.metric) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('goals', 'metric', filter.metric),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              start: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              due: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.targetRange) {
        const [start, end] = filter.targetRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            target: {
              ...where.target,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            target: {
              ...where.target,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.startRange) {
        const [start, end] = filter.startRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            start: {
              ...where.start,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            start: {
              ...where.start,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.dueRange) {
        const [start, end] = filter.dueRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            due: {
              ...where.due,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            due: {
              ...where.due,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.progressRange) {
        const [start, end] = filter.progressRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            progress: {
              ...where.progress,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            progress: {
              ...where.progress,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.type) {
        where = {
          ...where,
          type: filter.type,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.goals.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('goals', 'title', query),
        ],
      };
    }

    const records = await db.goals.findAll({
      attributes: ['id', 'title'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['title', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.title,
    }));
  }
};
